
#ifdef HI_TECH_C
 /* #include "cr3ht.h" */	/* if use HI-TECH C then include */
#endif
/* CR3 Ver 1.1 COLUMNS like game for MSX2
  (C) Masaki Oba 2017
  http://nabeta.tk
  admin@nabeta.tk
license: 2-Clause BSD License
target OS: MSX-DOS and MSX-BASIC(MSX DISK BASIC)
target machine: MSX2 computer or MSX2 emulator.
  MSX2 emulator work on Windows,HTML5,Mac OS,Linux...
support C compiler:
    BDS C V1.60 with asu ansi2kr(ANSI C to K&R converter)
        or
    HI-TECH C Ver 3.90(CP/M)
porting from BASIC language program,
COLUMNS modoki "Micom BASICmagazine" August 1990,88page.
*/
/*
if use 8bit charcters(Non mask MSB) then
require "7bit-String to 8bit-String" patch for BDS C
binary file patch.
BDS C v1.60 "CC.COM" binary file 29D4H, 7F to FF.
BDS C v1.50a "CC.COM" binary file 26C7H, 7F to FF.
alpha-C v1.51 "CC.COM" binary file 26F1H, 7F to FF.

source file patch.
(if choose binary patch then no need source file patch)
BDS C v1.60 make from source file
"CCC.ASM" 1988 line "stripp: ani 7fh" to "stripp: ani ffh"
"CC.ASM" 17 line "zsystem equ true" to "zsystem equ false"
assemble on CP/M "lasm cc.ccz c:"
*/
/*
compile by BDS C on Windows
(require CP/M program EXEcutor for Win32, asu ansi2kr)
(asu ansi2kr is the ANSI C to K&R coverter)
(CP/M program EXEcutor for Win32 is the CP/M emulator for Windows. http://hp.vector.co.jp/authors/VA000084/")
(BDS C support MSX-DOS executable file and MSX-DISK-BASIC executable file)
delete #include "cr3ht.h" to head of cr3.c
makecr3msxdos.bat
    or
makecr3basic.bat
*/
/*
compile by HI-TECH C(CP/M) on Windows
(require CP/M program EXEcutor for Win32)
(CP/M program EXEcutor for Win32 is the CP/M emulator for Windows. http://hp.vector.co.jp/authors/VA000084/")
(HI-TECH C support only MSX-DOS executable file)
(HI-TECH C not support MSX-DISK-BASIC executable file)
add #include "cr3ht.h"  to head of cr3.c
cpm c cr3.c masc.c mascht.c msxcg.c
          or
cpm c cr3.c masc.c mascht.c libm.lib
(libm.lib == MSX-C Library gokan(compatible) library for HI-TECH C  http://www.vector.co.jp/soft/other/msx/se148476.html)
(if use msxcg.c then no need libm.lib)
*/
/* assemble Z80 library for BDS C on Windows
(require AAPP, zcasmb , zmac)
(AAPP is the asu assembler preprocessor)
(zcasmb.exe is the Z80 assembly language link to BDS C tool for Windows)
(zmac is the Z80 macro assembler for Windows. http://www.48k.ca/zmac.html)
crlmakemsxdos.bat masa    (for make MSX-DOS executable file)
crlmakemsxdos.bat masa2    (for make MSX-DOS executable file)
crlmakebasic.bat masa    (for make MSX-DISK-BASIC executable file)
crlmakebasic.bat masa2   (for make MSX-DISK-BASIC executable file)
*/
/*
  run on MSX-DOS (BDS C and HI-TECH C support)
  A>cr3
     or
  (if rename to cr3ht.com)
  A>cr3ht

  run on MSX-DISK-BASIC (BDS C support , HI-TECH C not support)
  bload "cr3.bin",r
*/

/* if "bdscio.h"(BDS C Ver 1.5a) rename to "stdio.h" */
#include <stdio.h>

/* External declaration for BDS C -e option.
global variable with BDS C -e option faster than internal variable or no option. */
/* (japanese)BDS C no -e opusyon wo tsukatte hayaku suru tame ni gaibu sengen. */
char i,ex,mx,my,nb,vy,y,x,l,uk,kj,bb,sz,mmx,mmy,mxx,myy,j,yy,yy2,w,crs,men;
char  mb[3],m[7][20],m2[7][20],soo[7],tt22,ssm[7][20],px,py,kg,mm;
char plr,plg,plb;
int sc,ob,vg,tt,ii,uux,uuy,vx,loy,ott,htt,saikou,ptt,rt;
int ab,spc;




void settei()
{
  switch(crs){
    case 17:	vg=1; htt=vg; ptt=vg; ott=6; tt=(vg+ott)/2; break;
    case 18:	vg=3; htt=vg; ptt=vg; ott=9; tt=(vg+ott)/2; break;
    case 19:	vg=5; htt=vg; ptt=vg; ott=22; tt=(vg+ott)/2; break;
    case 20:	vg=15; htt=vg; ptt=vg; ott=30; tt=(vg+ott)/2; break;
    case 21:	vg=20; htt=vg; ptt=vg; ott=60; tt=(vg+ott)/2; break;
  }
  sc=0;
}

void se2()
{
  locate(22,3);sput("STG ");putdeg(men); 

  locate(9,8);chput(0xb1);chput(0xb1);sput("\1Y       \1X");chput(0xb1);chput(0xb1);
  /* locat() like the MSX-BASIC LOCATE.
    (japanese)hikisuu syouryaku dekinai. kaasoru sicchi kinou nashi. */
  /* sput() like the puts() but no check Ctrl+Stop,Ctrl+C,Ctrl+S. and faster than puts() */

  for(sz=9;sz<20;sz++){
    locate(9,sz);
    chput(0xb1);
    chput(0xb1);
    sput("\1V       \1V");
    chput(0xb1);
    chput(0xb1);
  }
  locate(9,20);
  chput(0xb1);
  chput(0xb1);
  sput("\1Z\1W\1W\1W\1W\1W\1W\1W\1[");
  chput(0xb1);
  chput(0xb1);
  locate(9,21);
  for(i=0;i<13;++i){
    chput(0xb1);
  }
  play("D FA /b /e G"); /* music of start */

  /* sc= score  vg,tt,tt2= speed  ex= relation X coordinate  ob= convert counter */  
  ex=12;ob=0;tt22=1;
  clik(0);	/* click sound off. clik(1)=ON} */
}

void zero()
{
  /* zero clear.
  (japanese)kore wo shinaito 2kaime kara baguru. */
  for(x=0;x<7;x++){
    for(y=0;y<20;y++){
      m[x][y]=0;
      m2[x][y]=0;
      ssm[x][y]=0;
    }
  }
}

void zke()
{
  /* cls */
  for(px=1;px<30;px++){
    for(py=0;py<24;py++){
      locate(px,py);chput(' ');
    }
  }
}

int kuria()
{
  play("c de ceg f badga f ee gga");
  /* for(ii=0;ii<8000;ii++); */
  wait(60);
  zke();
  locate(10,8);sput("GREATEST SCORE  "); putdeg(sc);

  locate(8,12);sput("YOU WIN");
  while(!strig(3) && !strig(1) && !strig(0) && !stick(0)){
    plr=rnd(8);
    plg=rnd(8);
    plb=rnd(8);
    palett(15,plr,plg,plb);
    if(stop()){
      pistl();
      screen(0);
      color(15,4,7);
      palett(15,7,7,7);
      return -1;
    }
  }
  palett(15,7,7,7);
  saikou=(sc>saikou) ? sc:saikou;
  kg=25;
  return 0;
}

void vkaki()
{
  for(px=1;px<=8;px++){
    for(py=1;py<22;py++){
      locate(px,py);chput('c');
    }
  }
  for(px=22;px<30;px++){
    for(py=1;py<22;py++){
      locate(px,py);chput('c');
    }
  }
  for(px=1;px<30;px++){
    locate(px,22);chput('c');
    locate(px,23);chput('c');
  }
}


int men2()
{
  if(men==1){
    play("bf ee ag bbd");
  }
  else{
    play("cf Be GCA Cd AE GFA");
  }
  /* for(ii=0;ii<8000;ii++); */
  wait(60);
  zke();
  locate(1,3);sput("SCORE "); putdeg(sc);
  locate(6,8);
  if(men==1){
    sput("YOU CLEAR STAGE 1");
    locate(10,10);sput("TRY STAGE 2");
  }
  else{
    sput("YOU CLEAR STAGE 2");
    locate(10,10);sput("TRY LAST STAGE");
  }
  ptt-=2;tt=ptt;vg=tt;ott=tt;htt-=2;
  while(!strig(3) && !strig(1) && !strig(0) && !stick(0)){
    plr=rnd(8);
    plg=rnd(8);
    plb=rnd(8);
    palett(15,plr,plg,plb);
    if(stop()){
      pistl();
      screen(0);
      color(15,4,7);
      palett(15,7,7,7);
      return -1;
    }
  }
  palett(15,7,7,7);

  men++;
  vkaki();
  locate(1,6);sput("SCORE "); putdeg(saikou); 
  locate(1,3);sput("HIGH  "); putdeg(sc);
  if(!saikou){
    locate(7,6);chput('0');
  }
  return 0;
}


int mroop()
{
  /* if locate(i,7)==block then game over */ 
  for(i=0;i<7;i++){
    if(m[i][7]){
      return -1;
    }
  }
  /* display decimal. putdeg(sc) like printf("%u",sc).
    but putdeg no check Ctrl+C. 
    work on MSX. does not work on CP/M.
    putdeg() slowly */
  locate (7,3); putdeg(sc);  

  if(sc>199 && men==1){
    if(men2() < 0){
      return -2; /* program end */
    }
    else{
      return 1; /* 2men */
    }
  }
  else
  if(sc>424 && men==2) {
    if(men2() < 0){
      return -2; /* program end */
    }
    else{
      return 1; /* 2men */
    }
  }
  else
  if(sc>649){
    if(kuria() < 0){
      return -2; /* program end */
    }
    return 2; /* game clear */
  }
  /* m[][] blocks array. block number 1-6 */
  /* m[3][5] == locate(3+ex,5) */

  uk=0;
  /* 3blocks first locate. mx,my */
  mx=3;my=255;	/* unsigned char 255 == signed char -1. 255+1==0; my==unsigned char */
  /* make new random 3 blocks. mb[]==3 blocks array. */
  for(i=0;i<3;i++){
    /* mb[i]=(rand()%6)+1; */
    mb[i]=rnd(6)+1;
  }
  return 0;
}

void xkesu()
{
  /* delete old locate 3 blocks */
  for(i=0;i<3;i++){
    mmx=mx+ex; mmy=my-i;
    locate(mmx,mmy);chput(' ');
  }
}

void mire()
{
  /* store 3 blocks of land to mb[][] */
  for(i=0;i<3;i++){
    mmy=my-i;
    if(mmy >= 0 && mmy < 20){
      m[mx][mmy]=mb[i];
    }
  }
}

void henkan()
{	
  /* turn 3 blocks. rotate */
  ob++;
  if(!(ob%2)){bb=mb[0];mb[0]=mb[1];mb[1]=bb;}
  else {bb=mb[1];mb[1]=mb[2];mb[2]=bb;}
  if(ob>9999) ob=0;
/*
  if(tt<800)for(ii=0;ii<500;ii++);
*/
}

void ks()
{
  while(1){
    mmx=x+(vx*l); mmy=y+(vy*l);
    if( mmx<7 && mmx>=0 && mmy<20 && mmy>4){
      if(m[mmx][mmy]==m[x][y]) {
        l++; 
        if(l<3){
          continue;
        }
        else{
          /* l>=3 then same color 3 blocks or over 3 blocks */
          kj=1; 	/* same color 3 blodks flag  */
          /* m2[][] == delete blocks array (1:delete  0:not delete) */	
          m2[mmx][mmy]=1;		/* set delete flag */
          m2[x][y]=1; mxx=x+vx; myy=y+vy; 
          m2[mxx][myy]=1; 
          /* same 3 blocks then delte 3 times */
          break;
        }
      }
    }
    break;
  }
}

void putblock(char block)
{
  switch(block){
    case 0:  chput(' '); break;
    case 1:  chput(224); break; /* 0xe0(224) blue block */
    case 2:  chput(216); break; /* 0xd8(216) red block */
    case 3:  chput(208); break; /* 0xd0(208) orange block */
    case 4:  chput(200); break; /* 0xc8(200) green block */
    case 5:  chput(192); break; /* 0xc3(192) light blue block */
    default: chput(184); break; /* 0xb8(184) yellow block */
  }
}

void nkaki()
{
  for(i=0;i<7;i++){
    for(j=5;j<20;j++){
      if(ssm[i][j]){
        mmx=ex+i;
        locate(mmx,j); 
        putblock(ssm[i][j]);
      }
    }
  }
}		

void nkesu1()
{
  for(i=0;i<7;i++){
    for(j=5;j<20;j++){
      if(m2[i][j]){
        mmx=ex+i;
        locate(mmx,j);chput(' ');
        ssm[i][j]=m[i][j];
      }
    }
  }
}		


void kensa2()
{
  for(x=0;x<7;x++){
    for(y=19;y>3;y--){
      if(m[x][y]){	/* if exist block in m[x][y] */
        for(i=0;i<4;i++){
          switch(i){
            case 0: vx=1;  vy=0; break; /* right */
            case 1: vx=1;  vy=1; break; /* lower right.(japanese.migi sita) */
            case 2: vx=0;  vy=1; break; /* down */
            case 3: vx=-1; vy=1; break; /* lower left.(japanese. hidari sita) */
          }
          l=1;
          ks();
        }
      }
    }
  }
}

void nkesu()
{
  kj=0;
  /* store delete block of line to soo[](0:not delete, 1:delete) */
  /* soo[] zero clear */
  for(i=0;i<7;i++){
    soo[i]=0;
  }
  for(i=0;i<7;i++){
    for(j=5;j<20;j++){
      if(m2[i][j]){
        /* delete */ 
        mmx=ex+i;
        locate(mmx,j);chput(' ');
        sc++; 		/* increment score. add 1 */ 
        /* deleted then  m[][],m2[][],ssm[][] zero clear */
        m[i][j]=0; m2[i][j]=0; ssm[i][j]=0;
        soo[i]++; 	/* store deleted block of line  */
      }
    }
  }
}		

int yd()
{
  w=19;
  while(m[x][w]) w--; /* search low ZERO */
  return w;
}

int y2d()
{
  do{
    w--;
  }while(!m[x][w] && w!=3);
  return w;
}


void tumeru()
{
  /*
    nkesu1(); play("C A"); wait(20);nkaki(); play("B F"); wait(20);nkesu1(); nkaki(); 
     play("C #D"); wait(20);nkesu(); play("D E"); nkesu();
  */
  nkesu1();
  play("D E");
  nkaki();
  nkesu();
  /*   ۯ     */
  for(x=0;x<7;x++){
    for(sz=0;sz<2;sz++){	/* some times exist 2 spaces. then 2 times */
      if(soo[x]){		/* space? */ 
        if(soo[x]<2){
          sz=2;  	/* if soo[]==1 then 1 space and loop 1 time. */
        }
        yy=yd();		/* search lowest space in X */
        yy2=y2d();		/* search lowest block from space. */
        if(yy2!=3){ 		/* if exist space(yy2==1 not exist space) */
          for(;/* yy2<254 bug? */ yy2 >= 0 && yy2 < 20;yy--,yy2--){
            m[x][yy]=m[x][yy2];

            mmx=ex+x;
            if(yy < 20 && yy >= 1){
              locate(mmx,yy);
              putblock(m[x][yy]);
            }
          }
        }
      }
    }
  }
}

void kensa()
{
  /* search same color 3 blocks. vertical,horizontal,oblique */
  /* (Japanese)burokku ga tate yoko naname ni 3tsu ijyou narande iruka kensa suru. */
  int ari;
  ari = 0;
  kj=0;	/* kj zero clear.befor kensa2() */
  while(1){
    kensa2();
    if(kj){
      ari = 1;
      /* same color 3 blocks (kj==1) */
      /* blink delete blocks , sound and jump to delete space */
      tumeru();
    }
    else{
      if(ari){
        return;
      }
      break;
    }
  }

  for(ab=0;ab<6;++ab){
    /* locate(1,8);sput("ab= "); putdeg(ab);sput("   "); */	
    if(strig(1) || strig(3) || stick(0)==1){
      henkan();
      /* display 3 blocks */
      for(i=0;i<3;i++){
        mmx=mx+ex; mmy=my-i;
        if(mmy < 20 && mmy >= 1){
          locate(mmx,mmy);
          putblock(mb[i]);
        }
      }
      mire(); 	/* store 3 blocks to m[][] */
      kj=0;	/* kj zero clear befor kensa2() */
      ari = 0;
      while(1){
        kensa2();
        if(kj){
          ari = 1;
          /* same color 3 blocks(kj==1) */
          /* blink delete blocks , sound and jump to delete space */
          tumeru();
        }
        else{
          if(ari){
            return;
          }
          break;
        }
      }
    }
    /* sleep(1); */
  }
}




void owari()
{
  locate(11,13);sput("GAME OVER");
  locate(15,20);
  sput("MASAKI OBA 2017");

  if(sc>saikou){
    saikou=sc; 
    play("E Ge CECA B C F CD D");
    for(i=0;i<4;i++){
      locate(1,3);sput("           ");
      /* for(ii=0;ii<5000;ii++); */
      wait(20);
      plr=rnd(8);
      plg=rnd(8);
      plb=rnd(8);
      palett(15,plr,plg,plb);
      locate(1,3);sput("SCORE "); putdeg(saikou);	
      /* for(ii=0;ii<5000;ii++); */
      wait(20);
    }
    locate(7,6);	putdeg(saikou); 
    palett(15,7,7,7);
  }
  else{play("c efg aF C  d gc");}
  /* for(ii=0;ii<1000;ii++); */
  wait(60);
}

int trig()
{
  while(!strig(3) && !strig(1) && !strig(0) && !stick(0)){
    plr=rnd(8);
    plg=rnd(8);
    plb=rnd(8);
    palett(15,plr,plg,plb);
    if(stop()){
      /* Ctrl+STOP(Page UP) program end */
      pistl();
      screen(0);
      color(15,4,7);
      palett(15,7,7,7);
      return -1;
    }
    wait(1);
  }
  palett(15,7,7,7);
  locate(12,6);sput("       ");
  locate(12,7);sput("       ");
  locate(12,5);sput("       ");
  locate(15,20);sput("       cccccccc");
  locate(7,3);sput("         ");
  locate(7,3);chput('0');
  men=1;
  return 0;
}


void kan3()
{
  int tmtf;
  while(1){
    /* for(ii=0;ii<vg;ii++); */ /* wait. speed down */
    wait(vg);
    /* stick() same function the BASIC's STICK */
    /* stick0() like stick(0). but check only vertical and horizontal. no check oblique.
      faster than stick(0).
      (Japanese)stick0() to stick(0) wa daitai onajidaga tate yoko sika sirabenai.
      naname wa chekku sinai.
    */
    /* if no input cursor key then check joystick. */
    nb=stick(0); if(!nb) nb=stick(1);
/*
speed check
locate(2,15);putdeg(vg);sput("   ");
locate(2,16);putdeg(htt);sput(" ");
locate(2,17);putdeg(ott);sput(" ");
*/
    vg=(nb==5)? 0:tt; 		/* push cursor DOWN key == speed up */
    /* strig() same function BASIC's STRIG */
    /* push cursor UP key or A/B button then rotate 3 blocks color */
    if(strig(1) || strig(3) || stick(0)==1) henkan();
    /* chput() like putch(). but chput faster than putch(). */
    /* if exist old 3 blocks(uk==1) then delete highest block in 3 blocks. */
    if(uk){
      mmx=mx+ex;
      mmy=my-3;
      locate(mmx,mmy);chput(' ');
    }
    /* if push joystick's right or left then check can move.
       if 3 block can move left or right then delete current 3 blocks. */
    if(nb==3 && mx<6){mmx=mx+1; if(!m[mmx][my]){xkesu();mx++;}}
    if(nb==7 && mx>0){mmx=mx-1; if(!m[mmx][my]){xkesu();mx--;}}

    /* speed up or speed down */
    ++spc;
    if((spc % 20) == 0){
      if(tt22){
        --tt;if(tt<htt)tt22=0;
      }
      else{
        ++tt;if(tt>ott)tt22=1;
      }
    }

    /* display 3 blocks */
    for(i=0;i<3;i++){
      mmx=mx+ex; mmy=my-i;
      if(mmy < 20 && mmy >= 1){
        locate(mmx,mmy);
        putblock(mb[i]);
      }
    }

    my++; 		/* 3blocks down 1 line. */
    if(my>19){
      tmtf = 1;
    }
    else
    if(m[mx][my]){
      tmtf = 1;
    }
    else{
      tmtf = 0;
    }

    if(tmtf){ 	/* land. (Japanese)chakuchi */
      my--; 	/* restore old line. because can not move down. */ 
      mire(); 	/* store 3blocks to m[][] */
      pistl(); 	/* pistol sound(landing sound) */ 
      kensa(); 	/* check same color 3 blocks. vertical, horizontal, oblique */
      break;
    } 
    else{
      uk=1;
      /* landing not yet */
      /* (Japanese)mada chakuchi site nai */
      /* uk=1 mean landing not yet. and not highest */
      /* uk=1 wa mada chakuchi sitenai. ichiban ue demo nai.to iu imi. */ 	
    }
  }
}

int ton2()
{
  /* change 'c' font to red brick graphic. */
  vpoke((0x63*8),32);	/* 'c'(code 0x63,99) = aka renga(red brick) graphic */
  vpoke((0x63*8+1),32);
  vpoke((0x63*8+2),32);
  vpoke((0x63*8+3),255);
  vpoke((0x63*8+4),2);
  vpoke((0x63*8+5),2);
  vpoke((0x63*8+6),2);
  vpoke((0x63*8+7),255);
  vpoke((0x2000+0x63/8),0x68);

  /* change 0x85(133) character font. for non japanese font */
  vpoke((0x85*8),0x3c);
  vpoke((0x85*8+1),0x7e);
  vpoke((0x85*8+2),0xff);
  vpoke((0x85*8+3),0xff);
  vpoke((0x85*8+4),0xff);
  vpoke((0x85*8+5),0xff);
  vpoke((0x85*8+6),0x7e);
  vpoke((0x85*8+7),0x3c);

  /* 0x85,s character font data
  _12345678
  1__****__ 0x3c
  2_******_ 0x7e
  3******** 0xff
  4******** 0xff
  5******** 0xff
  6******** 0xff
  7_******_ 0x7e
  8__****__ 0x3c
  */



#if 0
  /* change character font.
    make cloned character font for broken charcter.
    this routine deleted.(comment out)(2017 years version.)
    because change Japanese charcter to romanized charcter */
  vpoke((111*8),0);	/* 'o' = hankaku hiragana 'to' */
  vpoke((111*8+1),132);
  vpoke((111*8+2),72);
  vpoke((111*8+3),48);
  vpoke((111*8+4),96);
  vpoke((111*8+5),128);
  vpoke((111*8+6),128);
  vpoke((111*8+7),124);
  vpoke((122*8),0);	/* 'z' = hankaku hiragana 'te' */
  vpoke((122*8+1),126);
  vpoke((122*8+2),4);
  vpoke((122*8+3),8);
  vpoke((122*8+4),16);
  vpoke((122*8+5),16);
  vpoke((122*8+6),8);
  vpoke((122*8+7),4);
  vpoke((112*8),32);	/* 'p' = hankaku dakuten */
  vpoke((112*8+1),144);
  vpoke((112*8+2),72);
  vpoke((112*8+3),32);
  vpoke((112*8+4),0);
  vpoke((112*8+5),0);
  vpoke((112*8+6),0);
  vpoke((112*8+7),0);
  vpoke((113*8),18);	/* 'q' = hankaku hiragana 'na' */
  vpoke((113*8+1),121);
  vpoke((113*8+2),32);
  vpoke((113*8+3),36);
  vpoke((113*8+4),68);
  vpoke((113*8+5),158);
  vpoke((113*8+6),37);
  vpoke((113*8+7),24);
  vpoke((114*8),0);	/* 'r' =  hankaku hiragana 'ta' */
  vpoke((114*8+1),32);
  vpoke((114*8+2),248);
  vpoke((114*8+3),32);
  vpoke((114*8+4),78);
  vpoke((114*8+5),64);
  vpoke((114*8+6),128);
  vpoke((114*8+7),142);
  vpoke((115*8),0);	/* 's' = hankaku hiragana 'chi' */
  vpoke((115*8+1),16);
  vpoke((115*8+2),252);
  vpoke((115*8+3),32);
  vpoke((115*8+4),120);
  vpoke((115*8+5),4);
  vpoke((115*8+6),4);
  vpoke((115*8+7),56);

  vpoke((116*8),0);	/* 't' =  hankaku katakana 'su' */
  vpoke((116*8+1),252);
  vpoke((116*8+2),4);
  vpoke((116*8+3),8);
  vpoke((116*8+4),16);
  vpoke((116*8+5),48);
  vpoke((116*8+6),72);
  vpoke((116*8+7),132);
  vpoke((117*8),0);	/* 'u' = hankaku  katakana(hiragana?) 'he' */
  vpoke((117*8+1),0);
  vpoke((117*8+2),32);
  vpoke((117*8+3),80);
  vpoke((117*8+4),136);
  vpoke((117*8+5),4);
  vpoke((117*8+6),2);
  vpoke((117*8+7),0);
  vpoke((118*8),64);	/* 'v' =  hankaku katakana handakuten */
  vpoke((118*8+1),160);
  vpoke((118*8+2),64);
  vpoke((118*8+3),0);
  vpoke((118*8+4),0);
  vpoke((118*8+5),0);
  vpoke((118*8+6),0);
  vpoke((118*8+7),0);
  vpoke((119*8),0);	/* 'w' = hankau chouboin  */
  vpoke((119*8+1),0);
  vpoke((119*8+2),0);
  vpoke((119*8+3),252);
  vpoke((119*8+4),0);
  vpoke((119*8+5),0);
  vpoke((119*8+6),0);
  vpoke((119*8+7),0);
  vpoke((120*8),0);	/* 'x' = hankaku katakana 'fu' */
  vpoke((120*8+1),0);
  vpoke((120*8+2),252);
  vpoke((120*8+3),4);
  vpoke((120*8+4),4);
  vpoke((120*8+5),8);
  vpoke((120*8+6),16);
  vpoke((120*8+7),96);
  vpoke((121*8),0);	/* 'y' = hankaku katakana 'ro' */
  vpoke((121*8+1),252);
  vpoke((121*8+2),132);
  vpoke((121*8+3),132);
  vpoke((121*8+4),132);
  vpoke((121*8+5),132);
  vpoke((121*8+6),132);
  vpoke((121*8+7),252);
  vpoke((123*8),0);	/* '{' = hankaku hiragana 'tsu' */
  vpoke((123*8+1),0);
  vpoke((123*8+2),248);
  vpoke((123*8+3),4);
  vpoke((123*8+4),2);
  vpoke((123*8+5),2);
  vpoke((123*8+6),12);
  vpoke((123*8+7),112);
  vpoke((124*8),0);	/* '|' = hankaku katakana 'ho' */
  vpoke((124*8+1),16);
  vpoke((124*8+2),254);
  vpoke((124*8+3),16);
  vpoke((124*8+4),16);
  vpoke((124*8+5),84);
  vpoke((124*8+6),146);
  vpoke((124*8+7),16);
  vpoke((125*8),0);	/* '}' = hankaku kanakana 'ta' */
  vpoke((125*8+1),60);
  vpoke((125*8+2),36);
  vpoke((125*8+3),36);
  vpoke((125*8+4),92);
  vpoke((125*8+5),4);
  vpoke((125*8+6),8);
  vpoke((125*8+7),48);
  vpoke((126*8),0);	/* '~' = hankaku katakana 'un' */
  vpoke((126*8+1),0);
  vpoke((126*8+2),132);
  vpoke((126*8+3),68);
  vpoke((126*8+4),4);
  vpoke((126*8+5),4);
  vpoke((126*8+6),8);
  vpoke((126*8+7),240);
#endif

  ckesu();  /* hide cursor */
  erafnk();  /* function key off  */
  locate(4,2);sput("CR3 (COLUMNS LIKE GAME)");
#ifdef HI_TECH_C
  locate(2,3);sput("COMPILE BY HI-TECH C V3.90");
#else
  locate(6,3);sput("COMPILE BY BDS C V1.6");
#endif
  locate(4,8);sput("PUSH SPACE KEY.");
  locate(6,12);sput("OR A / B BUTTON.");
  locate(9,17);sput("VERY FAST");
  locate(12,19);sput("NORMAL");
  locate(14,18);sput("FAST");
  locate(14,20);sput("SLOW");
  locate(19,19);chput(133);
  locate(9,21);sput("VERY SLOW");
  play("E dG  fC A  bD");
  crs=19;
  while(!strig(1) && !strig(3) && !strig(0)){
    plr=rnd(8);
    plg=rnd(8);
    plb=rnd(8);
    palett(15,plr,plg,plb);
    if((stick(0)==1 || stick(1)==1) && crs>17){
      locate(19,crs);chput(' ');
      crs--;
      locate(19,crs);chput(133);
      wait(20);
    }
    if((stick(0)==5 || stick(1)==5) && crs<21){
      locate(19,crs);chput(' ');
      crs++;
      locate(19,crs);chput(133);
      wait(20);
    }
    if(stop()){
      pistl();
      screen(0);
      color(15,4,7);
      palett(15,7,7,7);
      return -1;
    }
  }
  palett(15,7,7,7);
  locate(4,2);sput("                       ");
  locate(6,3);sput("                     ");
  locate(4,8);sput("               ");
  locate(6,12);sput("                ");
  locate(9,17);sput("           ");
  locate(12,19);sput("        ");
  locate(14,18);sput("      ");
  locate(14,20);sput("      ");
  locate(9,21);sput("         ");
  /* write VRAM and character change color  */
  vpoke(8214,238); /* charcter 0xb1 change gray color */
  vpoke(8215,11); /* character 0xb8(184) yellow */
  vpoke(8216,7); /* character 0xc3(192) light blue */
  vpoke(8217,2); /* character 0xc8(200) green */
  vpoke(8218,13); /* character 0xd0(208) orange */
  vpoke(8219,6); /* character 0xd8(216) red */
  vpoke(8220,4);/* character 0xe0(224) blue */

  for(ii=0;ii<=328;ii++){
    if(!(ii%8)){
      loy=-1;
    }
    else{
      loy=0;
    }
    uux=1472+ii;
    uuy=1-(254*loy);
    vpoke(uux,uuy); /* change font data to fill */
  }

  vkaki();
  locate(1,6);sput("HIGH  ");
  putdeg(saikou);
  locate(1,3);sput("SCORE 0");
  
  /* srand(-(timel())); */
  men=1;
  return 0;
}

int ton()
{
  if(ton2() < 0){
    /* Ctrl+STOP(Page UP) program end */
    return -1;
  }
  mm = 0;
  while(1){
    if(mm == 0){
      settei();
    }
    se2();
    zero();
    while(1){
      mm = 0;
      rt = mroop();
      if(rt == -1){
        /* game over */
        owari();
        if(trig() < 0){
          /* Ctrl+STOP(Page UP) program end */
          return -1;
        }
        return 0;
      }
      else
      if(rt == -2){
        /* Ctrl+STOP(Page UP) program end */
        return -1;
      }
      else
      if(rt == 1){
        /* 2men */
        mm = 1;
        break;
      }
      else
      if(rt == 2){
        /* game clear */
        return 0;
      }
      /* if 3 blocks 1 color remake color */
      if(mb[0]==mb[1] && mb[0]==mb[2]){
        continue;
      }
      else{
        kan3();
        continue;
      }
    }
  }
  return 0;
}

void main()
{
  int cpumode;
  cpumode = getcpu();
  /* printf("cpumode=%d\n",cpumode); */
  z80mode();
  while(1){
    kg = 0;
    cls();
    color(15,1,1);	/* color() like the BASIC's COLOR */
    screen(1);	/* screen() like the BASIC's SCREEN  */  
    color(15,1,1);	/* need call color() 2 times? */
    rt = ton();
    if(rt == -1){
      /* Ctrl+STOP(Page Up) program end */
      break;
    }
  }
  if(cpumode > 0){
    printf("try change to r800mode\n");
    r800mode();
    cpumode = getcpu();
  }

  if(cpumode > 0){
    printf("r800mode\n");
  }
  else{
    printf("z80mode\n");
  }

  printf("CR3   END      \n");
}

