
/*   ihexa.c */
/* asu hex2bin ver 1.0 */
/* (C) Masaki Oba 2017 */
/*  2-Clause BSD License. */
/* compile
   check only bcc32
   Windows Borland(#define WINDOWS)(Convert to SJIS)
      bcc32 -DWINDOWS ihex2bin.c ihex.c

   no check
   UNIX cc(#define UNIX)
      cc -o hex2bin -DMACOSX hoja.c ihexa.c

   no check
   UNIX gcc(#define UNIX)
      gcc -o hex2bin hoja.c ihexa.c

   no check
   Windows Microsoft(#define WINDOWS)(Convert to SJIS)
      cl -DWINDOWS hex2bin.c ihexa.c

   no check
   Mac OS X XCode(#define MACOSX)(OS no namae igai wa UNIX to onaji)
      cc -o hex2bin -DMACOSX hoja.c ihexa.c

   no check
   MS-DOS DJGPP(MS-DOS gcc)(#define GO32)(Convert to SJIS)
      gcc -DGO32 hex2bin.c ihexa.c

*/

#include <stdio.h>
#include <stdlib.h>
/* #include <malloc.h> */

#define HEXLINESIZE 1000


unsigned char mem[65536];
#ifdef TANTAITEST
unsigned bc;
int Alpf;	/* 0:kanji mode  1:roma ji mode */
#else
extern unsigned bc;
extern int Alpf;	/* 0:kanji mode  1:roma ji mode */
#endif

struct kawari_st{
  unsigned short start;
  unsigned short end;
};

int H4err;

/* 16sinsuu moji? */
int ishex(char abc)
{
  if((abc >='0' && abc <='9') || (abc >= 'A' && abc <='F')) 
    return 0;
  else
    return 1;
}

/* kani hexfile check zenbu wa sirabenai */
/* return 1; tabun hex file */
/* return 0; tabun binary file */
/*
int ihexck(char *bbbb)
{
  int i;
  if(bbbb[0]!=':')
    return 0;
  for(i=1;i<11;++i){
    if(ishex(bbbb[i]))
      return 0;
  }
  return 1;
}
*/

int hex1toi(char abc)
{

  if(abc >='0' && abc <='9'){
    abc -= '0';
  }
  else
  if(abc >='A' && abc <='F'){
    abc -= ('A'-10);
  }
  else
    return -1;
  return (int)abc;
}

/* 4moji 16sinsuu -> int */
unsigned long hex4tou(char *abc)
{
  unsigned aaa1,aaa2,aaa3,aaa4;
  unsigned long gk;

  aaa1 = *abc;
  aaa2 = *(abc+1);
  aaa3 = *(abc+2);
  aaa4 = *(abc+3);
  if(ishex(aaa1) || ishex(aaa2) || ishex(aaa3) || ishex(aaa4)){
    H4err = -1;  
    return 0;
  }
  else
    H4err = 0;
  aaa1 = hex1toi(aaa1);
  aaa2 = hex1toi(aaa2);
  aaa3 = hex1toi(aaa3);
  aaa4 = hex1toi(aaa4);
  
  gk = (unsigned long) aaa4;
  gk += (unsigned long) ((aaa3)*16);
  gk += (unsigned long) ((aaa2)*256);
  gk += (unsigned long) ((aaa1)*4096);
  return gk;   
}


/* 2moji 16sinsuu -> int */
int hex2toi(char *abc)
{
  int aaa1,aaa2;

  aaa1 = *abc;
  aaa2 = *(abc+1);
  if(ishex(aaa1) || ishex(aaa2)){
    H4err = -1;
    return -1;
  }
  else
    H4err = 0;
  aaa1 = hex1toi(aaa1);
  aaa2 = hex1toi(aaa2);
  return (aaa1 * 16) + aaa2;   
}

/******************************/
/* check sum and  hex -> binary */
/* retun 0;  OK */
/* return -1; NG */
/******************************/
int sumcheck(char *line,int rb,unsigned char *hexdata)
{
  unsigned sum;
  int a;
  unsigned char b;
  int i;
  sum = 0;
  for(i=0;i<rb+5;++i,line+=2){
    if(ishex(*line) || ishex(*(line+1)))
      return -1;
    a = hex2toi(line);
    sum += a;
    if(i>3 && i < rb+4){
      *hexdata = a;
      ++hexdata;
    }
  }
  b = sum;
  return (int)b;
}


void hexallocerr(void)
{
    if(Alpf)
    	fprintf(stderr,"cannot alloc memory(hex file)\n");
    else{
/*KANJI*/      fprintf(stderr,"wLTt@Cp̃mۂł܂B\n");
    }
}

int hex(char *inpname,unsigned long *minad,unsigned long *maxad)
{
  FILE *fp;
  int i;
  char hexline[HEXLINESIZE+5];
  unsigned char hexdata[HEXLINESIZE+5];
  int err;
  int rb;	/* record byte */
  unsigned long ad;	/* address */
  unsigned long line_end_adress;	/* line end address */
  unsigned long min_adress = 0xffff;
  unsigned long max_adress = 0;
  int rt;	/* record type */
  unsigned long segment;	/* hex file segment */
  

  err = 0;
  segment = (long)0;	/* hexfile segment */
  
  for(i=0;i<65536;++i){
    mem[i] = 0;
  }

#ifdef WINDOWS
  if(NULL == (fp=fopen(inpname,"rt"))){
#else
#ifdef GO32
  if(NULL == (fp=fopen(inpname,"rt"))){
#else
  if(NULL == (fp=fopen(inpname,"r"))){
#endif
#endif

    if(Alpf){
      fprintf(stderr,"file cannot open[%s]\n",inpname);
    }
    else{
/*KANJI*/      fprintf(stderr,"t@CJ܂B[%s]\n",inpname);
    }
    return -1;
  }

  while(1){
    if(NULL == (fgets(hexline,HEXLINESIZE,fp))){
      break;
    } 
    if(hexline[0]!=':'){
      err = 1;
      break;
    }
    if(ishex(hexline[1]) || ishex(hexline[2])){
      err = 1;
      break;
    }
    rb = hex2toi(&hexline[1]); 	/* line data binary size */
    if(H4err){
      err = 1;
      break;
    }
    H4err = 0;
    if(sumcheck(&hexline[1],rb,hexdata)){
      err = 2;
      break;
    }
    if(H4err){
      err = 1;
      break;
    }
    ad = hex4tou(&hexline[3]);	/* address */
    if(H4err){
      err = 1;
      break;
    }
    rt = hex2toi(&hexline[7]);	/* record type */
    if(H4err){
      err = 1;
      break;
    }
    if(rt <0 || rt>5){
      err = 1;
      break;
    }
    if(rt > 2){
      err = 4;
      break;
    }
    if(rt == 2){	/* segment data */
      if(rb!=2){
        err = 1;
        break;
      }
      segment = hex4tou(&hexline[9]) *16;
      if(H4err){
        err = 1;
        break;
      }
    }
    else
    if(!rt){	/* data record */
      if(rb){
        if(ad + segment +rb-1 > 0xffff){
          err = 3;
          break;
        }
        if(ad + segment < min_adress){
          min_adress = ad +segment;
        }
        line_end_adress = ad+segment+rb-1;
        if(line_end_adress > max_adress){
          max_adress = line_end_adress;
        }

        for(i=0;i<rb;++i){
          mem[ad+segment+i]=hexdata[i];
        }
      }
    }
    if(rt == 1){		/* end of file record */
      break;
    }
  }
  fclose(fp);
  if(err == 1){
    if(Alpf)
      fprintf(stderr,"intel hex file syntax error\n");
    else{
/*KANJI*/      fprintf(stderr,"CewLTt@C@G[\n");
    }
  }
  else
  if(err == 2){
    if(Alpf)
      fprintf(stderr,"intel hex file sum check error \n");
    else{
/*KANJI*/      fprintf(stderr,"CewLTt@C `FbNTG[\n");
    }
  }
  else
  if(err == 3){
    if(Alpf)
      fprintf(stderr,"extended hex file address 64k over\n");
    else{
/*KANJI*/      fprintf(stderr,"gCewLTt@C AhX64kz\n");
    }
  }
  else
  if(err == 4){
    if(Alpf)
      fprintf(stderr,"intel hex file record type 3-5 taiou site imasen.\n");
    else{
/*KANJI*/      fprintf(stderr,"CewLT R[h^Cv3-5 ΉłB\n");
    }
  }
  *minad = min_adress;
  *maxad = max_adress;
  return err;
}

#ifdef TANTAITEST
int main(int argc,char **argv)
{
  unsigned long min_ad;
  unsigned long max_ad;
  int err;

  if(argc < 2){
    printf("ihex filename\n");
    return 1;
  }
  err = hex(argv[1],&min_ad,&max_ad);
  printf("minad = %lx , max_ad = %lx \n",min_ad,max_ad);
  if(err){
    return 1;
  }
  return 0;
}
#endif 


